% ------------------------------------------------------------------------------
% Copyright (c) 2019, 2025 Contributors to the Eclipse Foundation
%
% See the NOTICE file(s) distributed with this work for additional
% information regarding copyright ownership.
%
% This program and the accompanying materials are made available under the terms
% of the MIT License which is available at https://opensource.org/licenses/MIT
%
% SPDX-License-Identifier: MIT
% ------------------------------------------------------------------------------
\documentclass{article}
\usepackage{tikz}
\usetikzlibrary{arrows.meta, arrows, automata, calc, positioning, shapes, shapes.misc}
\usepackage[paperwidth=40in, paperheight=20in]{geometry}

\begin{document}
\pagestyle{empty}

\begin{tikzpicture}[
    auto,
    ->,
    node distance=4cm,
    every state/.style={ellipse, semithick, fill=black!5, minimum size=1.5cm, font=\Large},
    initial distance=1.2cm,
    every initial by arrow/.style={-{Stealth[scale=1.4]}},
    initial text=,
    transform shape,
    double distance=2pt,
    every loop/.style={min distance=10mm}
]

\node[state, initial, accepting] (A) {\emph{OffOpen}};
\node[state, right=3cm of A]     (B) {\emph{OnOpen}};

\node[state, below=3cm of A]     (C) {\emph{OffClosed}};
\node[state, below=3cm of B]     (D) {\emph{OnClosed}};

\path[-{Stealth[scale=1.4]}]
    (A) edge[bend left] node[align=center] {\texttt{turn\_on}}  (B)
    (B) edge[bend left] node[align=center] {\texttt{close}}     (D)
    (D) edge[bend left] node[align=center] {\texttt{turn\_off}} (C)
    (C) edge[bend left] node[align=center] {\texttt{open}}      (A)
;

\end{tikzpicture}
\end{document}
